=== debian/changelog ===
suitesparse (1:5.1.2-2) unstable; urgency=medium

  * Add missing Depends of libsuitesparse-dev on libgraphblas1.
    (Closes: #887570)

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 19 Jan 2018 18:09:10 +0100

suitesparse (1:5.1.2-1) unstable; urgency=medium

  * New upstream version 5.1.2
  * Update Vcs-* fields for move to salsa.debian.org.

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 07 Jan 2018 11:46:33 +0100

suitesparse (1:5.1.2~beta2-1) unstable; urgency=medium

  * New upstream version 5.1.2~beta2
    + libgraphblasdemo now linked against libm. (Closes: #885569)
  * Bump Standards-Version to 4.1.3.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 02 Jan 2018 14:04:44 +0100

suitesparse (1:5.1.2~beta-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 27 Dec 2017 10:12:05 +0100

suitesparse (1:5.1.2~beta-1) experimental; urgency=medium

  * New upstream version 5.1.2~beta
  * graphblas-build.patch: drop patch, applied upstream.
  * d/watch: support -beta suffix (treating it as ~beta).
  * d/rules: remove kludge for renaming static GraphBLAS lib.
  * Bump to debhelper compat level 11:
    - documentation now installed under /u/s/doc/libsuitesparse-dev
    - directly call make instead of dh_auto_build (the latter messes up with the
      INSTALL parameter)

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 25 Dec 2017 22:14:41 +0100

suitesparse (1:5.1.1-beta-1) experimental; urgency=medium

  * New upstream version 5.1.1-beta
    - fixes FTBFS on some 32-bit platforms (Closes: #884564)
    - static GraphBLAS library is now shipped in -dev package.
  * Drop patches applied upstream: cmake.patch, pdf-docs.patch.
  * graphblas-build.patch: new patch for GraphBLAS build system.
  * Update symbols file for libgraphblas1.
  * Add missing epoch in symbols files.

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 21 Dec 2017 21:36:15 +0100

suitesparse (1:5.1.0-1) experimental; urgency=medium

  * New upstream version 5.1.0
  * d/copyright: reflect upstream changes.
  * SOVERSION bump for libsuitesparseconfig (4 -> 5).
  * Package new GraphBLAS library:
    + new libgraphblas1 package.
    + add Build-Depends on cmake.
    + cmake.patch: new patch, fixes installation paths of the library.
    + install GraphBLAS.h include in libsuitesparse-dev.
    + install GraphBLAS_Userguide.pdf, and register it into doc-base.
  * Rebuild PDF doc.
    + add some texlive build-depedencies.
    + new pdf-docs.patch
  * d/rules: drop obsolete override for dbgsym migration.
  * Bump to Standards-Version 4.1.2.
  * Install README.txt in libsuitesparse-doc (instead of libamd2).
  * Drop useless README.Debian.
  * Add source lintian override for insecure URL in d/watch.

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 09 Dec 2017 22:21:24 +0100
