=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/" http://www.suitesparse.com \
(?:|.*/)SuiteSparse(?:[_\-]v?|)(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
